#define S_SOFT_RESET 0x01
#define S_DISPLAY_ON_OFF 0x02
#define S_ANALOG_CONTROL 0x0F    //
#define S_STANDBY_ON_OFF 0x14
#define S_OSC_ADJUST 0x1A
#define S_ROW_SCAN_DIRECTION 0x09
#define S_DISPLAY_X1 0x30
#define S_DISPLAY_X2 0x31
#define S_DISPLAY_Y1 0x32
#define S_DISPLAY_Y2 0x33
#define S_DISPLAYSTART_X 0x38
#define S_DISPLAYSTART_Y 0x39
#define S_CPU_IF 0x0D
#define S_MEM_X1 0x34
#define S_MEM_X2 0x35
#define S_MEM_Y1 0x36
#define S_MEM_Y2 0x37
#define S_MEMORY_WRITE_READ 0x1D
#define S_DDRAM_DATA_ACCESS_PORT 0x08
#define S_DISCHARGE_TIME 0x18
#define S_PEAK_PULSE_DELAY 0x16
#define S_PEAK_PULSE_WIDTH_R 0x3A
#define S_PEAK_PULSE_WIDTH_G 0x3B
#define S_PEAK_PULSE_WIDTH_B 0x3C
#define S_PRECHARGE_CURRENT_R 0x3D
#define S_PRECHARGE_CURRENT_G 0x3E
#define S_PRECHARGE_CURRENT_B 0x3F
#define S_COLUMN_CURRENT_R 0x40
#define S_COLUMN_CURRENT_G 0x41
#define S_COLUMN_CURRENT_B 0x42
#define S_ROW_OVERLAP 0x48
#define S_SCAN_OFF_LEVEL 0x49
#define S_ROW_SCAN_ON_OFF 0x17
#define S_ROW_SCAN_MODE 0x13
#define S_SCREEN_SAVER_CONTROL 0xD0
#define S_SS_SLEEP_TIMER 0xD1
#define S_SCREEN_SAVER_MODE 0xD2
#define S_SS_UPDATE_TIMER 0xD3
#define S_RGB_IF 0xE0
#define S_RGB_POL 0xE1
#define S_DISPLAY_MODE_CONTROL 0xE5


#define Noir     0x00,0x00  //        (000,000,000)
#define Maron    0x80,0x00 //        (128,000,000)
#define Rouge    0xFF,0x00 //        (255,000,000)
#define Vert     0x08,0x00 //        (000,128,000)
#define Lime     0x0F,0xF0 //        (000,255,000)
#define Olive    0x80,0x80 //        (128,128,000)
#define Jaune    0xFF,0xF0 //        (255,255,000)
#define Navy     0x00,0x80 //        (000,000,128)
#define Blue     0x00,0xFF //        (000,000,255)
#define Violet   0x80,0x08 //        (128,000,128)
#define Fushia   0xFF,0x0F //        (255,000,255)
#define Teal     0x08,0x08 //        (000,128,128)
#define Aqua     0x0F,0xFF //        (000,255,255)
#define Gris     0x80,0x80 //        (128,128,128)
#define Argent   0xC0,0xC0 //        (192,192,192)
#define Blanc    0xFF,0xFF //        (255,255,255)