/*
 * catcatcat@e-mail.ua
 * CNK111063 SEPS114A
 *  ILLISSI-4B-PIC18F25K20
 * 
 * D0-RB0 \
 * D1-RB1 |
 * D2-RB2 |
 * D3-RB3 \ 
 * D4-RB4 /
 * D5-RB5 |
 * D6-RB6 |
 * D7-RB7/
 * A0-RA0 - 
 * CSB-RA1 -
 * RDB-RA2 ,
 * WRB-RA3 -
 * RSTB-RA4, 0 -
 * VCC_C-RA5  DC/DC
 * 96RGB?96
 * Microchip MPLAB XC8 C Compiler V1.12
 * Created on 28  2013 ., 22:19
 */


//----------------------------------------------------
#include <htc.h>
#include "graphic.h"
//----------------------------------------------------
#pragma jis    
       
//----------------------------------------------------

//    /*SCREEN_SAVER_CONTEROL (D0h)*/
//    OledWriteCom(0xD0, 0x90); //SMON -0x80 - 
//    /*SS_SLEEP_TIMER (D1h)*/
//    OledWriteCom(0xD1, 0x015);
//    /*SCREEN_SAVER_MODE (D2h)*/
//    OledWriteCom(0xD2, 0x00); 
//    /*SS_UPDATE_TIMER (D3h)
//    OledWriteCom(0xD3, 0x05);
//----------------------------------------------------

void OledEnVcc (char enable_disable)
{
char a;
    VCC_C_OLED=enable_disable;      
    VCC_C_TRIS=0;           
    for(a=0;a<100;a++) __delay_ms (1);
}//



void OledWriteCom (char IR, char datain)
{
    OLED_DATA=IR;     

//    OLED_TRIS=0;      
    CSB_OLED=0;       
    A0_OLED=0;         
    WRB_OLED=0;       
    RDB_OLED=1;         
    RDB_OLED=0;        
    CSB_OLED=1;    
    OLED_DATA=datain;     

    CSB_OLED=0;    
    A0_OLED=1;     
    WRB_OLED=0;     
    RDB_OLED=1;       
    RDB_OLED=0;    
    CSB_OLED=1;  
}



void OledData (void)/
{
//     
    OLED_DATA=0x08;    

//    OLED_TRIS=0;    
    CSB_OLED=0;   
    A0_OLED=0;   
    WRB_OLED=0;   
    RDB_OLED=1;  
    RDB_OLED=0;   
    CSB_OLED=1;    
}


void OledPict (void)
{
    OLED_DATA=color_pic01;
//    OLED_TRIS=0;       

    CSB_OLED=0;     
    A0_OLED=1; 
    WRB_OLED=0; 
    RDB_OLED=1;     
    RDB_OLED=0;    
    CSB_OLED=1;     

    OLED_DATA=color_pic02; 

    CSB_OLED=0;    
    A0_OLED=1;    
    WRB_OLED=0;        
    RDB_OLED=1;        
    RDB_OLED=0;       
    CSB_OLED=1;     
}

void OledFon (void)
{
    OLED_DATA=color_fon01;  
//    OLED_TRIS=0;       
    CSB_OLED=0;     
    A0_OLED=1;   
    WRB_OLED=0;   
    RDB_OLED=1;     
    RDB_OLED=0;    
    CSB_OLED=1;   
    OLED_DATA=color_fon02;  

    CSB_OLED=0;  
    A0_OLED=1;   
    WRB_OLED=0;  
    RDB_OLED=1;  
    RDB_OLED=0;     
    CSB_OLED=1;   
}


void OledFic_read (void)//
{
//char redata;
    OLED_DATA=0x08;    
//    OLED_TRIS=0;      
    CSB_OLED=0;   
    A0_OLED=0;      
    WRB_OLED=0;   
    RDB_OLED=1;       
    RDB_OLED=0;   
    CSB_OLED=1;    

    OLED_TRIS=0xFF;     

    CSB_OLED=0;  
    A0_OLED=1;    
    WRB_OLED=1;  
    RDB_OLED=1;   
    RDB_OLED=0;       
    CSB_OLED=1;       
    OLED_TRIS=0;    
}


//

//char OLEDread_comm  (char IR, char datain)
//{
//char redata;
//    CSB_OLED=0;         //
//    A0_OLED=0;          // 0-
//    RDB_OLED=1;         // 1-
//    OLED_DATA=IR;    
//    OLED_TRIS=0;    
//    WRB_OLED=0;       
//    WRB_OLED=1;      
//    CSB_OLED=1;        
//

//    CSB_OLED=0;       
//    A0_OLED=1;      
//    WRB_OLED=1;      
//    OLED_TRIS=0xFF;   
//    RDB_OLED=0;       
//    RDB_OLED=1;     
//    redata=OLED_DATA; 
//    CSB_OLED=1;      
// return redata;      
//}

//==============================================================================

void OledInt (void)
{
    OledEnVcc (0);       
 //   __delay_ms (11);   
    OLED_DATA = 0;     
    OLED_TRIS = 0;      

    A0_OLED = 1;      
    CSB_OLED = 1;     
    RDB_OLED = 1;    
    WRB_OLED = 1;        
    RSTB_OLED = 1;         
    VCC_C_OLED = 0;    

    A0_TRIS = 0;     
    CSB_TRIS = 0;   
    RDB_TRIS = 0;  
    WRB_TRIS = 0;      
    RSTB_TRIS = 0;   
    VCC_C_TRIS = 0;     

    __delay_us (5);    
    RSTB_OLED = 1;         

//    OledWriteCom(0x01, 0x00);
    /* Standby off */
    OledWriteCom(0x14, 0x00);
    __delay_ms(1); // wait for 1ms
    /* Set Oscillator operation */
    OledWriteCom(0x0F, 0x00); // using external resistor and internal OSC
    /* Set frame rate */
    OledWriteCom(0x1A, 0x0a); // frame rate : 130 Hz130 Hz
    /* Set MCU Interface */
    OledWriteCom(0x0D, 0x00); // MPU External interface mode, 8bits
    /*RGB_IF (E0h)*/
    OledWriteCom(0xE0, 0x00);
    // Set display mode control SWAP - 1-RGB/0-BGR  RC, DC -
    OledWriteCom(0xE5, 0x80); //SWAP:RGB, Reduce current : Normal, DC[1:0] : Normal
    /* Set row overlap */
    OledWriteCom(0x48, 0x00); // Band gap only

    /* Set discharge time */
    OledWriteCom(0x18, 0x08); // Discharge time : normal discharge
    /* Set peak pulse delay */
    OledWriteCom(0x16, 0x05);
    /* Set peak pulse width */
    OledWriteCom(0x3A, 0x05);
    OledWriteCom(0x3B, 0x05);
    OledWriteCom(0x3C, 0x05);
    /* Set precharge current */
    OledWriteCom(0x3D, 0x1F);
    OledWriteCom(0x3E, 0x1F);
    OledWriteCom(0x3F, 0x1F);
    /* Set column current */
    OledWriteCom(0x40, 0x5F);
    OledWriteCom(0x41, 0x5F);
    OledWriteCom(0x42, 0x5F);

    /* Set scan off level */
    OledWriteCom(0x49, 0x04); //VCC_C*0.75
 //-----------------------------------------------
    /* Set row scan direction */
    OledWriteCom(0x09, 0x00); // 2/0      
    /* Set row scan mode */
    OledWriteCom(0x13, 0x00); // Alternate scan mode 0 - 0,1,2,,94,95,0,1,2,.../1 - 1,0,3,2,5,4
    // Set Memory Read/Write mode 
    OledWriteCom(0x1D, 0x00); 
//---------------------------------------------
    // Set memory area(address) to write a display data
    OledWriteCom(0x34, 0);
    OledWriteCom(0x35, 95);
    OledWriteCom(0x36, 0);
    OledWriteCom(0x37, 95);
    // Set memory access point
    OledWriteCom(0x38, 0);
    OledWriteCom(0x39, 0);
    // Set active display area of panel
    OledWriteCom(0x30, 0);
    OledWriteCom(0x31, 95);
    OledWriteCom(0x32, 0);
    OledWriteCom(0x33, 95);

    OledWriteCom(0x02, 0x01);
    OledClearAll();
    OledEnVcc (1);           

}//


void OledClearAll (void)
{
    int a;
    OledWriteCom(0x1D, 0); 
    OledWriteCom(0x34, 0);
    OledWriteCom(0x35, 95);
    OledWriteCom(0x36, 0);
    OledWriteCom(0x37, 95);
    OledData (); 
    for (a=0;a<9216;a++)
    {
        OLED_DATA=0;  
    //    OLED_TRIS=0;      
        CSB_OLED=0;       
        A0_OLED=1;      
        WRB_OLED=0;    
        RDB_OLED=1;    
        RDB_OLED=0;         
        CSB_OLED=1;        


        OLED_DATA=0;   
        CSB_OLED=0;     
        A0_OLED=1;       
        WRB_OLED=0;      
        RDB_OLED=1;   
        RDB_OLED=0;        
        CSB_OLED=1;    
    }
}
//---------------------------------------------------------------------------------
/*
 *  0-15
 *                              R G B     R   G   B
 * 0-Black ()	 	      #000000	(000,000,000)
 * 1-Maroon (-)  #800000	(128,000,000)
 * 2-Red ()            #FF0000	(255,000,000)
 * 3-Green ()	 	  #008000	(000,128,000)
 * 4-Lime (-)	  #00FF00	(000,255,000)
 * 5-Olive ()	 	  #808000	(128,128,000)
 * 6-Yellow ()	 	  #FFFF00	(255,255,000)
 * 7-Navy (-)	 	  #000080	(000,000,128)
 * 8-Blue ()	 	      #0000FF	(000,000,255)
 * 9-Purple ()	  #800080	(128,000,128)
 * 10-Fuchsia ()	 	  #FF00FF	(255,000,255)
 * 11-Teal (-)	  #008080	(000,128,128)
 * 12-Aqua ( )	  #00FFFF	(000,255,255)
 * 13-Gray ()            #808080	(128,128,128)
 * 14-Silver ()	  #C0C0C0	(192,192,192)
 * 15-White ()           #FFFFFF	(255,255,255)
 *
 */
void OledColorFast (unsigned char colP, unsigned char colF)

 /*  RRRRRGGG       GGGBBBBB*/
 /* color_pic01  color_pic02*/
 /* color_fon01  color_fon02*/
//----------------------------
 unsigned char Rp,Gp,Bp,Rf,Gf,Bf;    
    
    Rp=0; //0-Black ()
    Gp=0;
    Bp=0;
    switch ( colP ) 
    {
        case 1 : //1-Maroon 
           Rp=128;
        break;
        case 2 : //2-Red 
           Rp=255;
        break;
        case 3 : //3-Green 
           Gp=128;
        break;
        case 4 : //4-Lime 
           Gp=255;
        break;
        case 5 : //5-Olive 
           Rp=128;
           Gp=128;
        break;
        case 6 : //6-Yellow 
           Rp=255;
           Gp=255;
        break;
        case 7 : //7-Navy 
           Bp=128;
        break;
        case 8 : //8-Blue
           Bp=255;
        break;
        case 9 : //9-Purple 
           Rp=128;
           Bp=128;
        break;
        case 10 : //10-Fuchsia 
           Rp=255;
           Bp=255;
        break;
        case 11 : //11-Teal 
           Gp=128;
           Bp=128;
        break;
        case 12 : //12-Aqua 
           Gp=255;
           Bp=255;
        break;
        case 13 : //13-Gray 
           Rp=128;
           Gp=128;
           Bp=128;
        break;
        case 14 : //14-Silver 
           Rp=192;
           Gp=192;
           Bp=192;
        break;
        case 15 : //15-White
           Rp=255;
           Gp=255;
           Bp=255;
        break;
    }

    Rf=0;
    Gf=0;
    Bf=0;
     switch ( colF ) 
    {
        case 1 : //1-Maroon 
           Rf=128;
        break;
        case 2 : //2-Red 
           Rf=255;
        break;
        case 3 : //3-Green 
           Gf=128;
        break;
        case 4 : //4-Lime 
           Gf=255;
        break;
        case 5 : //5-Olive 
           Rf=128;
           Gf=128;
        break;
        case 6 : //6-Yellow 
           Rf=255;
           Gf=255;
        break;
        case 7 : //7-Navy 
           Bf=128;
        break;
        case 8 : //8-Blue 
           Bf=255;
        break;
        case 9 : //9-Purple
           Rf=128;
           Bf=128;
        break;
        case 10 : //10-Fuchsia 
           Rf=255;
           Bf=255;
        break;
        case 11 : //11-Teal 
           Gf=128;
           Bf=128;
        break;
        case 12 : //12-Aqua
           Gf=255;
           Bf=255;
        break;
        case 13 : //13-Gray 
           Rf=128;
           Gf=128;
           Bf=128;
        break;
        case 14 : //14-Silver 
           Rf=192;
           Gf=192;
           Bf=192;
        break;
        case 15 : //15-White 
           Rf=255;
           Gf=255;
           Bf=255;
        break;
    }
//----------------------------
OledColorSet (Rp,Gp,Bp,Rf,Gf,Bf);
}
//---------------------------------------------------------------------------------




//---------------------------------------------------------------------------------
//    
//    ,     RGB (0-255)
void OledColorSet (unsigned char Rr, unsigned char Gr, unsigned char Br,unsigned char Rf, unsigned char Gf, unsigned char Bf)//    
{
 /*   0-31/  0-63/  0-31*/
 /*  RRRRRGGG       GGGBBBBB*/
 /* color_pic01  color_pic02*/
    /*  RGB  thousands of color*/
    Rr=3100/(25500/Rr);
    Gr=6300/(25500/Gr);
    Br=3100/(25500/Br);
    color_pic01 = Rr;
    color_pic01 = color_pic01<<3;
    color_pic01 = color_pic01|Gr>>3;
    color_pic02 = Gr;
    color_pic02 = color_pic02<<5;
    color_pic02 = color_pic02|Br;
        /*  RGB  thousands of color*/
    Rf=3100/(25500/Rf);
    Gf=6300/(25500/Gf);
    Bf=3100/(25500/Bf);
    color_fon01 = Rf;
    color_fon01 = color_fon01<<3;
    color_fon01 = color_fon01|Gf>>3;
    color_fon02 = Gf;
    color_fon02 = color_fon02<<5;
    color_fon02 = color_fon02|Bf;

}

// X - 0-132; Y - 0-64
void OledNewCor(unsigned char X, unsigned char Y)
{
    cursorY = Y; 
    cursorX = X; 
}


/* 
 * XS -
 * YS -
 * XE - 
 * YE - 
 * tip 
 * NAP -(0-7)
 * colorN -  1 (0-15)
 * colorS -  2 (0-15)
*/
void OledFillRect (char XS,char YS,char XE,char YE,char tip,char NAP,char colorN,char colorS)//  
{
    char a,colorRI,colorGI,colorBI;
    char Rp,Gp,Bp,Rf,Gf,Bf,VYS,SHI;
    char masck,b,c;
//-----------------------------------------------------------------------------
    OledWriteCom(0x1D, NAP);
    OledWriteCom(0x34, XS);
    OledWriteCom(0x35, XE);
    OledWriteCom(0x36, YS);
    OledWriteCom(0x37, YE);
//-----------------------------------------------------------------------------

     switch ( NAP ) 
    {
        case 0 :
        case 1 :
        case 2 :
        case 3 :
           VYS=YE-YS;
           SHI=XE-XS;
        break;
        case 4 :
        case 5 :
        case 6 :
        case 7 :
           VYS=XE-XS;
           SHI=YE-YS;
        break;
    }
//----------------------------
    Rp=0; //0-Black 
    Gp=0;
    Bp=0;
    switch ( colorN ) 
        case 1 : //1-Maroon 
           Rp=128;
        break;
        case 2 : //2-Red 
           Rp=255;
        break;
        case 3 : //3-Green 
           Gp=128;
        break;
        case 4 : //4-Lime 
           Gp=255;
        break;
        case 5 : //5-Olive 
           Rp=128;
           Gp=128;
        break;
        case 6 : //6-Yellow 
           Rp=255;
           Gp=255;
        break;
        case 7 : //7-Navy 
           Bp=128;
        break;
        case 8 : //8-Blue 
           Bp=255;
        break;
        case 9 : //9-Purple 
           Rp=128;
           Bp=128;
        break;
        case 10 : //10-Fuchsia (
           Rp=255;
           Bp=255;
        break;
        case 11 : //11-Teal 
           Gp=128;
           Bp=128;
        break;
        case 12 : //12-Aqua 
           Gp=255;
           Bp=255;
        break;
        case 13 : //13-Gray 
           Rp=128;
           Gp=128;
           Bp=128;
        break;
        case 14 : //14-Silver 
           Rp=192;
           Gp=192;
           Bp=192;
        break;
        case 15 : //15-White 
           Rp=255;
           Gp=255;
           Bp=255;
        break;
    }

    Rf=0;
    Gf=0;
    Bf=0;
     switch ( colorS ) 
    {
        case 1 : //1-Maroon 
           Rf=128;
        break;
        case 2 : //2-Red 
           Rf=255;
        break;
        case 3 : //3-Green 
           Gf=128;
        break;
        case 4 : //4-Lime 
           Gf=255;
        break;
        case 5 : //5-Olive 
           Rf=128;
           Gf=128;
        break;
        case 6 : //6-Yellow 
           Rf=255;
           Gf=255;
        break;
        case 7 : //7-Navy 
           Bf=128;
        break;
        case 8 : //8-Blue 
           Bf=255;
        break;
        case 9 : //9-Purple 
           Rf=128;
           Bf=128;
        break;
        case 10 : //10-Fuchsia 
           Rf=255;
           Bf=255;
        break;
        case 11 : //11-Teal 
           Gf=128;
           Bf=128;
        break;
        case 12 : //12-Aqua 
           Gf=255;
           Bf=255;
        break;
        case 13 : //13-Gray 
           Rf=128;
           Gf=128;
           Bf=128;
        break;
        case 14 : //14-Silver
           Rf=192;
           Gf=192;
           Bf=192;
        break;
        case 15 : //15-White 
           Rf=255;
           Gf=255;
           Bf=255;
        break;
    }
//----------------------------

    colorRI=(Rf-Rp)/VYS;
    colorGI=(Gf-Gp)/VYS;
    colorBI=(Bf-Bp)/VYS;

    OledData (); 
    OledColorSet (Rp, Gp, Bp,0,0,0);
    for (a=0;a<=VYS;a++)
    {
       if(tip)
       {
            if(c)masck=0x55;
            else masck=0xAA;
            for (b=0;b<=SHI;b++)
            {
                if(masck&0b00000001)
                {
                    OledPict();
                }
                else
                {
                    OledFic_read ();
                    OledFic_read ();
                    OledFic_read ();
                }
                masck = (masck >> 1) | (masck << 7); 
            }
            if(!c)c=1;
            else c=0;
        }
        else
        {
            for (b=0;b<=SHI;b++)
            {
                OledPict();
            }
        }
        Rp=Rp+colorRI;
        Gp=Gp+colorGI;
        Bp=Bp+colorBI;
        OledColorSet (Rp, Gp, Bp,0,0,0);
    }
 }//
//---------------------------------------------------------------------------------


// OledString 
/*
 * str
 * prop - 
 * nalo -
 * width-[0- 7
 * height
 * X-
 *  Y 0-62]
 */
void OledString(const char *str,char prop,char nalo,char width,char height,char X,char Y)// , char c, , ,  (22   )
{
    int ptr = 0;            /
    if (X & 0b10000000)       
    {
        while (str[ptr] != 0) ptr++;
        ptr=(dispX-((ptr*5*(width==0?1:width))+(prop*ptr)))/2;
        if(ptr<0)ptr=0; 
        OledNewCor (ptr, Y);
        ptr = 0;
    }
    else OledNewCor (X, Y);
    while (str[ptr] != 0) OledSymbol (str[ptr++],prop,nalo,width,height);	//        ( )
}//


/*
 * prop - 
 * nalo -  0-1 -
 * width- 0-   7
 * height-
 
 */
void OledStringCur(const char *str,char prop,char nalo,char width,char height)
{
    int ptr = 0; 
    while (str[ptr] != 0) OledSymbol (str[ptr++],prop,nalo,width,height);	
}//


//---------------------------------------------------------------------------------
// X - 0-132; Y - 0-64
// cod - 
// tip - 
// sti - 
// shi -  0/1
// vis -  0/1

void OledSymbol(unsigned char cod, unsigned char tip, unsigned char sti, unsigned char shi, unsigned char vis)
{

unsigned int codv;
unsigned char b, a, z, mask, bufr, vm, am;
unsigned long risun1, risun2, bufr1, bufr2;

       if (!shi)shi++; 
    shi = shi & 0b00000111; 
    if (!vis)vis++; 
    vis = vis & 0b00000111; 
    codv = (cod - 0x20)*5;  
    
    //-------------------------------
    OledWriteCom(0x1D, 0x04);
    OledWriteCom(0x34, cursorX);
    OledWriteCom(0x35, cursorX+(shi*5));
    OledWriteCom(0x36, cursorY);
    OledWriteCom(0x37, cursorY+(vis*8)-1);
    //----------------------------
    OledData ();        
    for (b = 0; b < 5; b++) 
    {
        bufr = SHRIFT[codv + b];
        mask = 0b10000000;
        risun1 = 0;
        risun2 = 0;
        for (z = 0; z < 8; z++)//8****
        {
            for (vm = 0; vm < vis; vm++)
            {
                risun2 <<= 1;
                if (risun1 & 0b10000000000000000000000000000000) risun2 |= 1;
                risun1 <<= 1;
                if (bufr & mask)risun1 |= 1;
//              if(z==7)vm=vis;
                if(z==7)break;
            }
            mask = mask >> 1; 
        } // end for(z=0;z<8;z++)

        for (a = 0; a < shi; a++)
        {
              cursorX++;
            bufr1 = risun1;
            bufr2 = risun2;
            for (am = 0; am < vis*8; am++)
            {
                if(am<32)
                {
                    if(bufr1& 0b00000000000000000000000000000001)
                    {
//                        OledData ();
                        OledPict();
                    }
                    else
                    {
                        if(sti)OledFon ();
                        else
                        {
                            OledFic_read (); 
                            OledFic_read (); 
                            OledFic_read (); 
                        }
                    }
                    bufr1>>=1;
                }
                else
                {
                    if(bufr2& 0b00000000000000000000000000000001)
                    {
//                        OledData ();
                        OledPict();
                    }
                    else
                    {
                        if(sti)OledFon ();
                        else
                        {
                            OledFic_read ();
                            OledFic_read (); 
                            OledFic_read (); 
                        }
                    }
                    bufr2>>=1;
                }
            }
        }
    }
    OledWriteCom(0x1D, 0x04); 
    OledWriteCom(0x34, cursorX);
    OledWriteCom(0x35, cursorX+(shi*5));
    OledWriteCom(0x36, cursorY);
    OledWriteCom(0x37, cursorY+(vis*8)-1);
    OledData (); 
    //------------------------------- 
    for (a = 0; a < tip; a++)
    {
        cursorX++;
        if(sti)
        {
            for (am = 0; am < vis*8; am++)
            {
                OledFon ();
            }
        }
    }
}//
//---------------------------------------------------------------------------------
//*str  max 255 
//tipvy -  0-   , 1- 
//shiS -  0-2 (0,1 == 1)
//vysS -  0-3 (0,1 == 1)
//X - 
//Y - 
//dlinokna -
void OledTicker (const char *str,char tipvy,char shiS,char vysS,char X,char Y,char dlinokna)
{
char a,b,Xnach;
char dlinst=0; 	
char colcim,dlinok; 
int ptr=0,sim; 					
    if(shiS==0)shiS=1;
    else if(shiS>2)shiS=2;
    if(vysS==0)vysS=1;
    else if(vysS>3)vysS=3;
    dlinok=dlinokna/(5*shiS);
    while (str[dlinst++] != 0); 

    if (dlinst>dlinok)
    {
        if (poz<dlinok){ptr=0; colcim=poz; Xnach=X+(dlinok-poz)*(6*shiS);}
        else
        if (poz<dlinst){ptr=poz-dlinok; colcim=dlinok; Xnach=X;}
        else
        {ptr=dlinst-dlinok+(poz-dlinst); colcim=dlinok-(poz-dlinst+1); Xnach=X;}
    }
    else
    {
        if  (poz<dlinst){ptr=0;	colcim=poz; Xnach=X+(dlinok-poz)*(6*shiS);}
        else
        if  (poz<dlinok){ptr=0;	colcim=dlinst-1; Xnach=X+(dlinok-poz)*(6*shiS);}
        else
        {ptr=dlinst-dlinok+(poz-dlinst); colcim=dlinok-(poz-dlinst+1); Xnach=X;}
    }
    cursorY = Y;
    if(tipvy)cursorX = X; 
    else cursorX = Xnach; 

    //------------------------------- 
    OledWriteCom(0x1D, 0x04); //
    OledWriteCom(0x34, cursorX);
    OledWriteCom(0x35, cursorX);
    OledWriteCom(0x36, cursorY);
    OledWriteCom(0x37, cursorY);
    //------------------------------- 


    for (b=0;b<colcim;b++) 
    {
        OledSymbol(str[ptr+b],1,1,shiS,vysS);
    }
    if (poz>=dlinst)
    {
        OledSymbol (' ',1,1,shiS,vysS);
    }
    poz++;
    if (dlinst==(poz-dlinok)) poz=0; 
}//

// Ticker
//tipvy -  0-, 1
//shiS -  0-2 (0,1 == 1)
//vysS -0-3 (0,1 == 1)
//X -   X


void OledTickerRAM (char tipvy,char shiS,char vysS,char X,char Y,char dlinokna)
{
char a,b,Xnach;
char dlinst=0; 		
char colcim,dlinok; 	
int ptr=0,sim; 				
    if(shiS==0)shiS=1;
    else if(shiS>2)shiS=2;
    if(vysS==0)vysS=1;
    else if(vysS>3)vysS=3;
    dlinok=dlinokna/(5*shiS);

	while (ca[dlinst++] != 0); 

    if (dlinst>dlinok)
    {
        if (pozB<dlinok){ptr=0; colcim=pozB; Xnach=X+(dlinok-pozB)*(6*shiS);}
        else
        if (pozB<dlinst){ptr=pozB-dlinok; colcim=dlinok; Xnach=X;}
        else
        {ptr=dlinst-dlinok+(pozB-dlinst); colcim=dlinok-(pozB-dlinst+1); Xnach=X;}
    }
    else
    {
        if  (pozB<dlinst){ptr=0;	colcim=pozB; Xnach=X+(dlinok-pozB)*(6*shiS);}
        else
        if  (pozB<dlinok){ptr=0;	colcim=dlinst-1; Xnach=X+(dlinok-pozB)*(6*shiS);}
        else
        {ptr=dlinst-dlinok+(pozB-dlinst); colcim=dlinok-(pozB-dlinst+1); Xnach=X;}
    }
    cursorY = Y; 

    if(tipvy)cursorX = X; 
    else cursorX = Xnach; 


    //------------------------------- 
    OledWriteCom(0x1D, 0x04); 
    OledWriteCom(0x34, cursorX);
    OledWriteCom(0x35, cursorX);
    OledWriteCom(0x36, cursorY);
    OledWriteCom(0x37, cursorY);
    //-------------------------------


    for (b=0;b<colcim;b++)
    {
        OledSymbol(ca[ptr+b],1,1,shiS,vysS);
    }
    if (pozB>=dlinst)
    {
        OledSymbol (' ',1,1,shiS,vysS);
    }
    pozB++;
    if (dlinst==(pozB-dlinok)) pozB=0; 
}//


void point(unsigned char tip, unsigned char X, unsigned char Y)
{
//    cursorX=X;
//    cursorY=Y;
    OledWriteCom(0x34, X);
    OledWriteCom(0x35, X);
    OledWriteCom(0x36, Y);
    OledWriteCom(0x37, Y);
    OledData ();
    if(!tip)OledPict();
    else OledFon ();
}//




void line(unsigned char tip, unsigned char x0, unsigned char y0, unsigned char x1, unsigned char y1)
{
#define abs(a)	(((a)> 0) ? (a) : -(a))
    int steep, t, vid;
    int deltax, deltay, error;
    int x, y;
    int ystep;

    steep = (abs(y1 - y0) > abs(x1 - x0)); 

    if (steep) { 
        t = x0;
        x0 = y0;
        y0 = t;
        t = x1;
        x1 = y1;
        y1 = t;
    }
    if (x0 > x1) { 
        t = x0;
        x0 = x1;
        x1 = t;
        t = y0;
        y0 = y1;
        y1 = t;
    }

    deltax = x1 - x0;
    deltay = abs(y1 - y0);
    error = 0;
    y = y0;

    if (y0 < y1) ystep = 1;
    else ystep = -1;
    for (x = x0; x < x1 + 1; x++) {
        if (tip == 0)vid = 0;
        else if (tip == 1)vid = 1;
        else vid = (x & tip) - 1;
        if (steep) point(vid, y, x);
        else point(vid, x, y);
        error += deltay;
        if ((error << 1) >= deltax) {
            y += ystep;
            error -= deltax;
        } 
    } 
} 


//---------------------------------------------------------------------------------

void rectangle(unsigned char ugl, unsigned char tip, unsigned char bor, unsigned char tipzal, unsigned char x0, unsigned char y0, unsigned char sh, unsigned char vs)
{
#define abs(a)	(((a)> 0) ? (a) : -(a))
    char a, b, x1, y1;
    char zaliv = 0;
    char steep, t, vid;
    char deltax, deltay, error;
    char x, y, poi;
    char ystep;
    char zx0, zy0, zy1, zx1;

    if (x0 + sh > dispX)sh = dispX - x0; 
    if (y0 + vs > dispY)vs = dispY - y0; 

    x1 = x0 + sh;
    y1 = y0 + vs;
    if (bor) {
        if (ugl == 0) 
        {
            b = 0;
            for (a = 0; a < bor; a++) {
                line(tip, x0 + b, y0 + a, x1 - b, y0 + a);
                line(tip, x1 - a, y0 + b, x1 - a, y1 - b);
                line(tip, x1 - b, y1 - a, x0 + b, y1 - a);
                line(tip, x0 + a, y1 - b, x0 + a, y0 + b);
                b++;
            }
            y0 = y0 + a - 1;
            y1 = y1 - a + 1;
            x0 = x0 + a - 1;
            x1 = x1 - a + 1;
        } else 
        {
            b = 0;
            for (a = 0; a < bor; a++) {
                line(tip, x0 + 4 + b, y0 + a, x1 - 4 - b, y0 + a);
                line(tip, x1 - a, y0 + 4 + b, x1 - a, y1 - 4 - b);
                line(tip, x1 - 4 - b, y1 - a, x0 + 4 + b, y1 - a);
                line(tip, x0 + a, y1 - 4 - b, x0 + a, y0 + 4 + b);

                point(tip, x0 + 1 + b, y0 + 2 + b);
                point(tip, x0 + 1 + b, y0 + 3 + b);
                point(tip, x0 + 2 + b, y0 + 1 + b);
                point(tip, x0 + 3 + b, y0 + 1 + b);

                point(tip, x1 - 1 - b, y0 + 2 + b);
                point(tip, x1 - 1 - b, y0 + 3 + b);
                point(tip, x1 - 2 - b, y0 + 1 + b);
                point(tip, x1 - 3 - b, y0 + 1 + b);

                point(tip, x1 - 1 - b, y1 - 2 - b);
                point(tip, x1 - 1 - b, y1 - 3 - b);
                point(tip, x1 - 3 - b, y1 - 1 - b);
                point(tip, x1 - 2 - b, y1 - 1 - b);

                point(tip, x0 + 1 + b, y1 - 2 - b);
                point(tip, x0 + 1 + b, y1 - 3 - b);
                point(tip, x0 + 2 + b, y1 - 1 - b);
                point(tip, x0 + 3 + b, y1 - 1 - b);

                b++;
            }
            y0 = y0 + a - 1;
            y1 = y1 - a + 1;
            x0 = x0 + a - 1;
            x1 = x1 - a + 1;
        }
    }

    if (tipzal > 0) {
        for (a = 1; a < (x1 - x0); a++) 
        {
            zy0 = y0 + 1; 
            zy1 = y1 - 1; 
            zx1 = zx0 = x0 + a; //
            if (ugl) {
                if (a > 3) poi = sh - a; 
                else poi = a;
                switch (poi) {
                    case 1:
                        zy0 = zy0 + 3;
                        zy1 = zy1 - 3;
                        break;
                    case 2:
                    case 3:
                        zy0 = zy0 + 1;
                        zy1 = zy1 - 1;
                        break;
                }
            }
            steep = (abs(zy1 - zy0) > abs(zx1 - zx0));
            if (steep) { 
                t = zx0;
                zx0 = zy0;
                zy0 = t;
                t = zx1;
                zx1 = zy1;
                zy1 = t;
            }
            if (zx0 > zx1) { 
                t = zx0;
                zx0 = zx1;
                zx1 = t;
                t = zy0;
                zy0 = zy1;
                zy1 = t;
            }
            deltax = zx1 - zx0;
            deltay = abs(zy1 - zy0);
            error = 0;
            y = zy0;
            if (zy0 < zy1) ystep = 1;
            else ystep = -1;
            for (x = zx0; x < zx1 + 1; x++) { 
                if (tipzal == 1)vid = 0;
                else if (tipzal == 2)vid = 1;
                else if (Flag.RIS2)vid = (x & 1);
                else vid = !(x & 1);
                if (steep) point(vid, y, x);
                else point(vid, x, y);
                error += deltay;
                if ((error << 1) >= deltax) {
                    y += ystep;
                    error -= deltax;
                }
            } //
            if (tipzal > 2) {
                zaliv++;
                if (zaliv == tipzal - 2) {
                    Flag.RIS2 = !Flag.RIS2;
                    zaliv = 0;
                }
            }
        }
    }
}


void OLED_rotation (char R)
{

}

void OLED_contrast (char Y)
{

}

-----------------------------------------------------------------------

void strip(unsigned char ugl, unsigned char tip, unsigned char tipzal, unsigned char x0, unsigned char y0, unsigned char sh, unsigned char vs, unsigned char vol)
{
#define abs(a)	(((a)> 0) ? (a) : -(a))
    char a, x1, y1, shir;
    char zaliv = 0;
    char steep, t, vid;
    char deltax, deltay, error;
    char x, y, poi;
    char ystep;
    char zx0, zy0, zy1, zx1;
    char dbar;
    //static bit RIS;

    dbar = sh * vol / 100;

    x1 = x0 + sh;
    y1 = y0 + vs;

    if (ugl == 0) 
    {
        line(tip, x0, y0, x1, y0);
        line(tip, x1, y0, x1, y1);
        line(tip, x1, y1, x0, y1);
        line(tip, x0, y1, x0, y0);
    } else 
    {
        line(tip, x0 + 4, y0, x1 - 4, y0);
        line(tip, x1, y0 + 4, x1, y1 - 4);
        line(tip, x1 - 4, y1, x0 + 4, y1);
        line(tip, x0, y1 - 4, x0, y0 + 4);

        point(tip, x0 + 1, y0 + 2);
        point(tip, x0 + 1, y0 + 3);
        point(tip, x0 + 2, y0 + 1);
        point(tip, x0 + 3, y0 + 1);

        point(tip, x1 - 1, y0 + 2);
        point(tip, x1 - 1, y0 + 3);
        point(tip, x1 - 2, y0 + 1);
        point(tip, x1 - 3, y0 + 1);

        point(tip, x1 - 1, y1 - 2);
        point(tip, x1 - 1, y1 - 3);
        point(tip, x1 - 3, y1 - 1);
        point(tip, x1 - 2, y1 - 1);

        point(tip, x0 + 1, y1 - 2);
        point(tip, x0 + 1, y1 - 3);
        point(tip, x0 + 2, y1 - 1);
        point(tip, x0 + 3, y1 - 1);
    }


    shir = x1 - x0;
    Flag.RIS1 = 0;
    if (tipzal > 0)
    {
        for (a = 1; a < (shir); a++) 
        {
            zy0 = y0 + 1; 
            zy1 = y1 - 1; 
            zx1 = zx0 = x0 + a; //
            if (ugl)
            {
                if (a > 3) poi = sh - a; 
                else poi = a;
                switch (poi)
                {
                    case 1:
                        zy0 = zy0 + 3;
                        zy1 = zy1 - 3;
                        break;
                    case 2:
                    case 3:
                        zy0 = zy0 + 1;
                        zy1 = zy1 - 1;
                        break;
                }
            }
            steep = (abs(zy1 - zy0) > abs(zx1 - zx0)); 
            if (steep)
            {
                t = zx0;
                zx0 = zy0;
                zy0 = t;
                t = zx1;
                zx1 = zy1;
                zy1 = t;
            }
            if (zx0 > zx1)
            { 
                t = zx0;
                zx0 = zx1;
                zx1 = t;
                t = zy0;
                zy0 = zy1;
                zy1 = t;
            }
            deltax = zx1 - zx0;
            deltay = abs(zy1 - zy0);
            error = 0;
            y = zy0;
            if (zy0 < zy1) ystep = 1;
            else ystep = -1;
            for (x = zx0; x < zx1 + 1; x++)
            { 
                if (a < dbar)
                {
                    if (tipzal == 1)vid = 0;
                    else if (tipzal == 2)vid = 1;
                    else if (Flag.RIS1)vid = (x & 1); 
                    else vid = !(x & 1);
                } 
                else vid = 1;

                if (steep) point(vid, y, x);
                else point(vid, x, y);

                error += deltay;
                if ((error << 1) >= deltax)
                {
                    y += ystep;
                    error -= deltax;
                }
            } //
            if (tipzal > 2)
            {
                zaliv++;
                if (zaliv == tipzal - 2)
                {
                    Flag.RIS1 = !Flag.RIS1;
                    zaliv = 0;
                }
            }
        }
    
}















//  WINDOWS
const char SHRIFT[] = {

        0x00,0x00,0x00,0x00,0x00,	// 0x20	
        0x00,0x00,0xF2,0x00,0x00,	// 0x21	!
        0x00,0xE0,0x00,0xE0,0x00,	// 0x22	"
        0x28,0xFE,0x28,0xFE,0x28,	// 0x23	#
        0x24,0x54,0xFE,0x54,0x48,	// 0x24	$
        0xC6,0xC8,0x10,0x26,0xC6,	// 0x25	%
        0x6C,0x92,0xAA,0x44,0x0A,	// 0x26	&
        0x00,0xA0,0xC0,0x00,0x00,	// 0x27	'
        0x38,0x44,0x82,0x00,0x00,	// 0x28	(
        0x00,0x00,0x82,0x44,0x38,	// 0x29	)
        0x28,0x10,0x7C,0x10,0x28,	// 0x2A	*
        0x10,0x10,0x7C,0x10,0x10,	// 0x2B	+
        0x00,0x00,0x0A,0x0C,0x00,	// 0x2C	,
        0x10,0x10,0x10,0x10,0x10,	// 0x2D	-
        0x00,0x00,0x06,0x06,0x00,	// 0x2E	.
        0x04,0x08,0x10,0x20,0x40,	// 0x2F	/

        0x7C,0x8A,0x92,0xA2,0x7C,	// 0x30	0
        0x00,0x42,0xFE,0x02,0x00,	// 0x31	1
        0x42,0x86,0x8A,0x92,0x62,	// 0x32	2
        0x84,0x82,0xA2,0xD2,0x8C,	// 0x33	3
        0x18,0x28,0x48,0xFE,0x08,	// 0x34	4
        0xE4,0xA2,0xA2,0xA2,0x9C,	// 0x35	5
        0x3C,0x52,0x92,0x92,0x0C,	// 0x36	6
        0x80,0x8E,0x90,0xA0,0xC0,	// 0x37	7
        0x6C,0x92,0x92,0x92,0x6C,	// 0x38	8
        0x60,0x92,0x92,0x94,0x78,	// 0x39	9
        0x00,0x00,0x6C,0x6C,0x00,	// 0x3A	:
        0x00,0x00,0x6A,0x6C,0x00,	// 0x3B	//
        0x10,0x28,0x44,0x82,0x00,	// 0x3C	<
        0x28,0x28,0x28,0x28,0x28,	// 0x3D	=
        0x00,0x82,0x44,0x28,0x10,	// 0x3E	>
        0x40,0x80,0x8A,0x90,0x60,	// 0x3F	?

        0x4C,0x92,0x9C,0x42,0x3C,	// 0x40	@
        0x7E,0x88,0x88,0x88,0x7E,	// 0x41	
        0xFE,0x92,0x92,0x92,0x6C,	// 0x42	
        0x7C,0x82,0x82,0x82,0x44,	// 0x43	
        0xFE,0x82,0x82,0x44,0x38,	// 0x44	D
        0xFE,0x92,0x92,0x92,0x82,	// 0x45	
        0xFE,0x90,0x90,0x90,0x80,	// 0x46	F
        0x7C,0x82,0x92,0x92,0x5E,	// 0x47	G
        0xFE,0x10,0x10,0x10,0xFE,	// 0x48	
        0x00,0x82,0xFE,0x82,0x00,	// 0x49	I
        0x04,0x02,0x82,0xFC,0x80,	// 0x4A	J
        0xFE,0x10,0x28,0x44,0x82,	// 0x4B	
        0xFE,0x02,0x02,0x02,0x02,	// 0x4C	L
        0xFE,0x40,0x20,0x40,0xFE,	// 0x4D	
        0xFE,0x20,0x10,0x08,0xFE,	// 0x4E	N
        0x7C,0x82,0x82,0x82,0x7C,	// 0x4F	

        0xFE,0x90,0x90,0x90,0x60,	// 0x50	
        0x7C,0x82,0x8A,0x84,0x7A,	// 0x51	Q
        0xFE,0x90,0x98,0x94,0x62,	// 0x52	R
        0x62,0x92,0x92,0x92,0x8C,	// 0x53	S
        0x80,0x80,0xFE,0x80,0x80,	// 0x54	
        0xFC,0x02,0x02,0x02,0xFC,	// 0x55	U
        0xF8,0x04,0x02,0x04,0xF8,	// 0x56	V
        0xFC,0x02,0x1C,0x02,0xFC,	// 0x57	W
        0xC6,0x28,0x10,0x28,0xC6,	// 0x58	
        0xE0,0x10,0x1E,0x10,0xE0,	// 0x59	Y
        0x86,0x8A,0x92,0xA2,0xC2,	// 0x5A	Z
        0x00,0xFE,0x82,0x82,0x00,	// 0x5B	[
        0x18,0x24,0x7E,0x24,0x18,	// 0x5C	
        0x00,0x82,0x82,0xFE,0x00,	// 0x5D	]
        0x20,0x40,0x80,0x40,0x20,	// 0x5E	^
        0x02,0x02,0x02,0x02,0x02,	// 0x5F	_

        0x00,0x00,0x80,0x40,0x00,	// 0x60	'
        0x04,0x2A,0x2A,0x2A,0x1E,	// 0x61	
        0xFE,0x12,0x22,0x22,0x1C,	// 0x62	b
        0x1C,0x22,0x22,0x22,0x04,	// 0x63	
        0x1C,0x22,0x22,0x12,0xFE,	// 0x64	d
        0x1C,0x2A,0x2A,0x2A,0x18,	// 0x65	
        0x10,0x7E,0x90,0x80,0x40,	// 0x66	f
        0x10,0x2A,0x2A,0x2A,0x3C,	// 0x67	g
        0xFE,0x10,0x20,0x20,0x1E,	// 0x68	h
        0x00,0x22,0xBE,0x02,0x00,	// 0x69	i
        0x04,0x02,0x22,0xBC,0x00,	// 0x6A	j
        0x00,0xFE,0x08,0x14,0x22,	// 0x6B	k
        0x00,0x82,0xFE,0x02,0x00,	// 0x6C	l
        0x3E,0x20,0x18,0x20,0x1E,	// 0x6D	m
        0x3E,0x10,0x20,0x20,0x1E,	// 0x6E	n
        0x1C,0x22,0x22,0x22,0x1C,	// 0x6F	o

        0x3E,0x28,0x28,0x28,0x10,	// 0x70	
        0x10,0x28,0x28,0x28,0x3E,	// 0x71	q
        0x3E,0x10,0x20,0x20,0x10,	// 0x72	r
        0x12,0x2A,0x2A,0x2A,0x24,	// 0x73	s
        0x20,0xFC,0x22,0x02,0x04,	// 0x74	t
        0x3C,0x02,0x02,0x04,0x3E,	// 0x75	u
        0x38,0x04,0x02,0x04,0x38,	// 0x76	v
        0x3C,0x02,0x0C,0x02,0x3C,	// 0x77	w
        0x22,0x14,0x08,0x14,0x22,	// 0x78	
        0x30,0x0A,0x0A,0x0A,0x3C,	// 0x79	
        0x22,0x26,0x2A,0x32,0x22,	// 0x7A	z
        0x00,0x10,0x6C,0x82,0x00,	// 0x7B	{
        0x00,0x00,0xFE,0x00,0x00,	// 0x7C	|
        0x00,0x82,0x6C,0x10,0x00,	// 0x7D	}
        0x08,0x10,0x10,0x08,0x08,	// 0x7E	~

//     /Here you can generate your own symbols

        0xFF,0x80,0x80,0x80,0x80,	// 0x7F  
        0x80,0x80,0x80,0x80,0x80,	// 0x80
        0x80,0x80,0xFF,0x80,0x80,	// 0x81
        0x80,0x80,0x80,0x80,0xFF,	// 0x82
        0xFF,0x00,0x00,0x00,0x00,	// 0x83
        0x00,0x00,0xFF,0x00,0x00,	// 0x84
        0x00,0x00,0x00,0x00,0xFF,	//
        0xFF,0x10,0x10,0x10,0x10,	//
        0x10,0x10,0x10,0x10,0x10,	// 0xE1
        0x01,0x01,0xFF,0x01,0x01,	// 0x11
        0x01,0x01,0x01,0x01,0xFF,	// 0x91
        0xFF,0x01,0x01,0x01,0x01,	// 0x51
        0x01,0x01,0x01,0x01,0x01,	// 0xD1
        0x10,0x10,0xFF,0x10,0x10,	// 0x31
        0x10,0x10,0x10,0x10,0xFF,	// 0xB1
        0xFF,0x80,0xBF,0xA0,0xA0,	// 0x71
        0xA0,0xA0,0xA0,0xA0,0xA0,	// 0xF1
        0xA0,0xBF,0x80,0xBF,0xA0,	// 0x09
        0xA0,0xA0,0xBF,0x80,0xFF,	// 0x89
        0xFF,0x00,0xFF,0x00,0x00,	// 0x49
        0x00,0xFF,0x00,0xFF,0x00,	// 0xC9
        0x00,0x00,0xFF,0x00,0xFF,	// 0x29
        0xFF,0x00,0xEF,0x28,0x28,	// 0xA9
        0x28,0x28,0x28,0x28,0x28,	// 0x69
        0x28,0xEF,0x00,0xEF,0x28,	// 0xE9
        0x28,0x28,0xEF,0x00,0xFF,	//
        0xFF,0x01,0xFD,0x05,0x05,	// 0x99
        0x05,0x05,0x05,0x05,0x05,	// 0x9A
        0x05,0xFD,0x01,0xFD,0x05,	// 0x9B
        0x05,0x05,0xFD,0x01,0xFF,	// 0x9C

        0x00,0x00,0x3E,0x22,0x3E,	// 0x9D 0  //small numbers
        0x00,0x00,0x00,0x00,0x3E,	// 0x9E 1
        0x00,0x00,0x2E,0x2A,0x3A,	// 0x9F 2
        0x00,0x00,0x2A,0x2A,0x3E,	// 0xA0 3
        0x00,0x00,0x38,0x08,0x3E,	// 0xA1 4
        0x00,0x00,0x3A,0x2A,0x2E,	// 0xA2 5
        0x00,0x00,0x3E,0x2A,0x2E,	// 0xA3 6
        0x00,0x00,0x20,0x20,0x3E,	// 0xA4 7
        0x00,0x00,0x3E,0x2A,0x3E,	// 0xA5 8
        0x82,0xBA,0xAA,0x92,0xBA,	// 0xA6 dli
        0x8A,0x8A,0x82,0xBA,0x82,	// 0xA7
        0x88,0x54,0x22,0x88,0x22,	// 0xA8 /heat
        0xAA,0xAA,0xAA,0xAA,0xAA,	// 0xA9 /smoke generator

        0x10,0x20,0x10,0x10,0x20,	// 0xAA	~// spe *
        0x20,0x40,0xFE,0x40,0x20,	// 0xAB	su *  /up Arrow
        0x08,0x04,0xFE,0x04,0x08,	// 0xAC	sd * //  /down Arrow
        0x10,0x10,0x54,0x38,0x10,	// 0xAD	sr *   ->right Arrow
        0x10,0x38,0x54,0x10,0x10,	// 0xAE	sl * <-  /right Arrow...
//  //double lines
        0x00,0x07,0x08,0x13,0x24,	// 0xAF	  
        0x28,0x28,0x28,0x28,0x28,	// 0xB0	  
        0x28,0x24,0x13,0x08,0x07,	// 0xB1	  
        0x00,0xFF,0x00,0xFF,0x00,	// 0xB2	  
        0x00,0x00,0xFF,0x00,0xFF,	// 0xB3	  
        0x00,0xE0,0x10,0xC8,0x24,	// 0xB4	  
        0x14,0x24,0xC8,0x10,0xE0,	// 0xB5	  
        0x14,0x14,0x14,0x14,0x14,	// 0xB6	  

        0x10,0x38,0x7C,0xFE,0x00,	// 0xB7	 
        0x00,0xFE,0x7C,0x38,0x10,	// 0xB8	 

        0x08,0x78,0xFC,0x78,0x08,	// 0xB9	kol * 
        0x63,0x25,0x18,0x18,0xA4,	// 0xBA	

        0x7E,0x42,0x42,0x42,0x7E,	// 0xBB	 
        0x7E,0x7E,0x7E,0x7E,0x7E,	// 0xBC	 
        0x30,0x0C,0x03,0x0C,0x30,	// 0xBD	
        0x80,0xFF,0x01,0x01,0xFF,	// 0xBE	

        0x60,0x90,0x90,0x60,0x00,	// 0xBF	 *
//   -  / national fonts - Russian
        0x7E,0x88,0x88,0x88,0x7E,	// 0xC0	
        0xFE,0x92,0x92,0x92,0x0C,	// 0xC1	
        0xFE,0x92,0x92,0x92,0x6C,	// 0xC2 
        0xFE,0x80,0x80,0x80,0xC0,	// 0xC3 
        0x07,0x8A,0xF2,0x82,0xFF,	// 0xC4 
        0xFE,0x92,0x92,0x92,0x82,	// 0xC5 
        0xEE,0x10,0xFE,0x10,0xEE,	// 0xC6 
        0x92,0x92,0x92,0x92,0x6C,	// 
        0xFE,0x08,0x10,0x20,0xFE,	// 
        0x3E,0x84,0x48,0x90,0x3E,	// 
        0xFE,0x10,0x28,0x44,0x82,	// 
        0x04,0x82,0xFC,0x80,0xFE,	// 
        0xFE,0x40,0x20,0x40,0xFE,	// 
        0xFE,0x10,0x10,0x10,0xFE,	// 
        0x7C,0x82,0x82,0x82,0x7C,	// 
        0xFE,0x80,0x80,0x80,0xFE,	// 
        0xFE,0x90,0x90,0x90,0x60,	// 
        0x7C,0x82,0x82,0x82,0x44,	// 
        0x80,0x80,0xFE,0x80,0x80,	// 
        0xE2,0x14,0x08,0x10,0xE0,	// 
        0x18,0x24,0xFE,0x24,0x18,	// 
        0xC6,0x28,0x10,0x28,0xC6,	// 
        0xFE,0x02,0x02,0x02,0xFF,	// 
        0xE0,0x10,0x10,0x10,0xFE,	// 
        0xFE,0x02,0xFE,0x02,0xFE,	// 
        0xFE,0x02,0xFE,0x02,0xFF,	// 
        0x80,0xFE,0x12,0x12,0x0C,	// 
        0xFE,0x12,0x0C,0x00,0xFE,	// 
        0x7E,0x12,0x12,0x12,0x0C,	// 
        0x44,0x82,0x92,0x92,0x7C,	// 
        0xFE,0x10,0x7C,0x82,0x7C,	// 
        0x62,0x94,0x98,0x90,0xFE,	// 

        0x04,0x2A,0x2A,0x2A,0x1E,	// 
        0x3C,0x52,0x52,0x92,0x8C,	// 
        0x3E,0x2A,0x2A,0x14,0x00,	// 
        0x3E,0x20,0x20,0x20,0x30,	// 
        0x07,0x2A,0x32,0x22,0x3F,	// 
        0x1C,0x2A,0x2A,0x2A,0x18,	// 
        0x36,0x08,0x3E,0x08,0x36,	// 
        0x22,0x22,0x2A,0x2A,0x14,	// 
        0x3E,0x04,0x08,0x10,0x3E,	// 
        0x1E,0x42,0x24,0x48,0x1E,	// 
        0x3E,0x08,0x14,0x22,0x00,	// 
        0x04,0x22,0x3C,0x20,0x3E,	// 
        0x3E,0x10,0x08,0x10,0x3E,	// 
        0x3E,0x08,0x08,0x08,0x3E,	// 
        0x1C,0x22,0x22,0x22,0x1C,	// o
        0x3E,0x20,0x20,0x20,0x3E,	// 
        0x3E,0x28,0x28,0x28,0x10,	// 
        0x1C,0x22,0x22,0x22,0x04,	// 
        0x20,0x20,0x3E,0x20,0x20,	// 
        0x30,0x0A,0x0A,0x0A,0x3C,	// 
        0x38,0x44,0xFE,0x44,0x38,	// 
        0x22,0x14,0x08,0x14,0x22,	// 
        0x3E,0x02,0x02,0x02,0x3F,	// 
        0x30,0x08,0x08,0x08,0x3E,	// 
        0x3E,0x02,0x3E,0x02,0x3E,	// 
        0x3E,0x02,0x3E,0x02,0x3F,	// 
        0x20,0x3E,0x0A,0x0A,0x04,	// 
        0x3E,0x0A,0x04,0x00,0x3E,	// 
        0x3E,0x0A,0x0A,0x04,0x00,	// 
        0x14,0x22,0x2A,0x2A,0x1C,	// 
        0x3E,0x08,0x1C,0x22,0x1C,	// 
        0x10,0x2A,0x2C,0x28,0x3E,	// 
};


